﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Generators {
  using HeuristicLab.Core;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Erc.Interfaces;

  internal static class ErcUtils {
    internal static int GetInteger(IReadOnlyIntegerErcOptions options, IRandom random) {
      var x = options.Constants.Count == 0
          ? 1
          : random.Next(0, options.Constants.Count + 1);

      var value = x < options.Constants.Count
        ? options.Constants[x]
        : random.Next(options.Start, options.End);

      return value;
    }

    internal static double GetDouble(IReadOnlyFloatErcOptions options, IRandom random) {
      var x = options.Constants.Count == 0 ?
            1 :
            random.Next(0, options.Constants.Count + 1);

      var value = x < options.Constants.Count
        ? options.Constants[x]
        : random.NextDouble() * (options.End - options.Start) + options.Start;

      return value;
    }

    internal static bool GetBoolean(IReadOnlyBooleanErcOptions options, IRandom random) {
      var value = options.GetRandom(random);
      return value;
    }

    internal static string GetString(IReadOnlyStringErcOptions options, IRandom random) {
      var value = StringGenerator.RandomString(options, random);
      return value;
    }

    internal static char GetChar(IReadOnlyCharErcOptions options, IRandom random) {
      var value = StringGenerator.RandomChar(options.Start, options.End + 1, random);
      return value;
    }

    internal static string GetName(IReadOnlyNameErcOptions options, IRandom random) {
      var value = StringGenerator.RandomString(options, random);
      return value;
    }
  }
}
